package com.appdatatracker.utils

import android.content.Context
import androidx.appcompat.app.AlertDialog
import com.appdatatracker.R


//common method to show alert dialog
fun Context.showAlertDialog(
    message: String = "",
    title: String = this.getString(R.string.alert),
    postiveBtnText: String = this.getString(R.string.ok),
    negativeBtnText: String = this.getString(R.string.cancel),
    handleClick: (positiveClick: Boolean) -> Unit = {},
    isCancelable: Boolean = true
) {


    val builder = AlertDialog.Builder(this)
    builder.setTitle(title)
    builder.setMessage(message)
    builder.setCancelable(isCancelable)
    builder.setPositiveButton(postiveBtnText) { dialog, which ->
        dialog.dismiss()
        handleClick(true)
    }
    if (negativeBtnText.isNotEmpty()) {
        builder.setNegativeButton(negativeBtnText) { dialog, which ->
            dialog.dismiss()
            handleClick(false)

        }
    }
    val dialog = builder.create()
    dialog.show()

}

